
	include	lvo/exec_lib.i
	include	lvo/dos_lib.i
	include	lvo/graphics_lib.i
	include	exec/libraries.i
	include	exec/memory.i
	include	exec/execbase.i
	include	exec/exec_lib.i
	include	libraries/dosextens.i

st	move.l	4.w,a6
	move.l	a6,_SysBase
	clr.l	returnMsg
	sub.l	a1,a1
	jsr	_LVOFindTask(a6)
	move.l	d0,a4
	tst.l	pr_CLI(a4)
	bne.s	.es
	lea	pr_MsgPort(a4),a0
	jsr	_LVOWaitPort(a6)
	lea	pr_MsgPort(a4),a0
	jsr	_LVOGetMsg(a6)
	move.l	d0,returnMsg
.es	lea	gn(pc),a1
	moveq	#39,d0
	jsr	_LVOOpenLibrary(a6)
	move.l	d0,_GFXBase
	beq	.nogfx
	lea	dn(pc),a1
	moveq	#39,d0
	jsr	_LVOOpenLibrary(a6)
	move.l	d0,_DOSBase
	beq	.nodos
	lea	sn(pc),a1
	moveq	#40,d0
	jsr	_LVOOpenLibrary(a6)
	tst.l	d0
	beq	.nopatch
	lea	cn(pc),a1
	moveq	#40,d0
	jsr	_LVOOpenLibrary(a6)
	tst.l	d0
	beq	.nopatch
	move.l	d0,a6
	clr.l	d0
	sub.l	a1,a1
	jsr	-$1E(a6)
	lea	namchip(pc),a0
	bsr	readcnf
	move.l	d0,prchip
	move.l	d1,memchip
	lea	namilvd(pc),a0
	bsr	readcnf
	move.l	d0,prilvd
	move.l	d1,memilvd
	lea	namdisp(pc),a0
	bsr	readcnf
	move.l	d0,prdisp
	move.l	d1,memdisp
	lea	namncgx(pc),a0
	bsr	readcnf
	move.l	d0,prncgx
	move.l	d1,memncgx
	move.l	#endofpatch-beginofpatch,d0
	clr.l	d1
	move.l	_SysBase(pc),a6
	jsr	_LVOAllocVec(a6)
	move.l	d0,pm
	beq.s	.nopatch
	jsr	_LVOForbid(a6)
	move.l	_GFXBase,a1
	move.w	#_LVOAllocBitMap,a0
	move.l	pm,d0
	jsr	_LVOSetFunction(a6)
	move.l	d0,oldabm
	tst.l	prncgx		;OpenLibrary() patched only if NOCGX present
	beq.s	.nopl
	move.l	_SysBase,a1
	move.w	#_LVOOpenLibrary,a0
	move.l	pm,d0
	addq.l	#2,d0
	jsr	_LVOSetFunction(a6)
	move.l	d0,oldopl
.nopl	lea	beginofpatch(pc),a0
	move.l	pm,a1
	move.w	#endofpatch-beginofpatch-1,d0
.nxb	move.b	(a0)+,(a1)+
	dbf	d0,.nxb
	jsr	_LVOCacheClearU(a6)
	jsr	_LVOPermit(a6)
.nopatch move.l	_DOSBase,a1
	jsr	_LVOCloseLibrary(a6)
.nodos	move.l	_GFXBase,a1
	jsr	_LVOCloseLibrary(a6)
.nogfx	tst.l	returnMsg
	beq.s	.endd
	jsr	_LVOForbid(a6)
	move.l	returnMsg,a1
	jsr	_LVOReplyMsg(a6)
.endd	moveq	#0,d0
	rts

readcnf	clr.l	-(sp)
	clr.l	-(sp)
	move.l	a0,d1
	move.l	#MODE_OLDFILE,d2
	move.l	_DOSBase,a6
	jsr	_LVOOpen(a6)
	move.l	d0,fh
	beq	.nofile
	move.l	d0,d1
	move.l	#fib_buffer,d2
	jsr	_LVOExamineFH(a6)
	tst.l	d0
	beq.s	.noex
	move.l	fib_buffer+fib_Size,d0
	addq.l	#4,d0
	move.l	#MEMF_CLEAR,d1
	move.l	_SysBase(pc),a6
	jsr	_LVOAllocVec(a6)
	move.l	d0,4(sp)
	beq.s	.noex
	move.l	d0,d2
	move.l	fh,d1
	move.l	fib_buffer+fib_Size,d3
	move.l	_DOSBase,a6
	jsr	_LVORead(a6)
	cmp.l	fib_buffer+fib_Size,d0
	bne.s	.noex
	move.l	4(sp),a0
	move.l	fib_Size,a1
	add.l	a0,a1
	clr.b	(a1)
	moveq.l	#10,d1
	clr.l	d2
.nb	move.b	(a0),d0
	beq.s	.eof
	cmp.b	d1,d0
	bne.s	.sb
	clr.l	d0
	addq.l	#1,d2
.sb	btst	#6,d0			;lowercase
	beq.s	.sc
	bclr	#5,d0
.sc	move.b	d0,(a0)+
	bra.s	.nb
.eof	move.l	d2,(sp)
.noex	tst.l	(sp)
	bne.s	.n
	move.l	4(sp),d1
	clr.l	4(sp)
	move.l	_SysBase,a6
	jsr	_LVOFreeVec(a6)
.n	move.l	fh,d1
	move.l	_DOSBase,a6
	jsr	_LVOClose(a6)
.nofile	move.l	(sp)+,d0
	move.l	(sp)+,d1
	rts

beginofpatch
	bra.s	newabm

; new OpenLibrary()

newopl	move.l	a5,-(sp)
	movem.l	a0-a1/a6/d0-d1/d4,-(sp)
	cmp.l	#'cybe',(a1)+
	bne.s	.yes
	cmp.l	#'rgra',(a1)+
	bne.s	.yes
	cmp.l	#'phic',(a1)+
	bne.s	.yes
	cmp.l	#'s.li',(a1)+
	bne.s	.yes
	cmp.l	#'brar',(a1)+
	bne.s	.yes
	cmp.b	#'y',(a1)+
	bne.s	.yes
	bsr	getname
	beq.s	.yes
	move.l	prncgx(pc),d4
	move.l	memncgx(pc),a6
	bsr.w	chkcnf
	beq.s	.yes
	movem.l	(sp)+,a0-a1/a6/d0-d1/d4
	clr.l	d0
	bra.s	.no
.yes	movem.l	(sp)+,a0-a1/a6/d0-d1/d4
	move.l	oldopl(pc),a5
	jsr	(a5)
.no	move.l	(sp)+,a5
	rts

bpsize	equ	0
bpcount	equ	4
bpflags	equ	8
bptable	equ	12
stsize	equ	4*8+4+4+4

; new AllocBitMap()

newabm	movem.l	d4/d5/a1/a5-a6,-(sp)
	movem.l	d0-d2/a0,-(sp)
	move.l	_SysBase(pc),a6
	bsr	getname
	beq.s	.04
	move.l	prchip(pc),d4
	beq.s	.01
	move.l	memchip(pc),a6
	bsr.w	chkcnf
	beq.s	.01
	bset	#1,d3			;set BMF_DISPLAYABLE
.01	move.l	prilvd(pc),d4
	beq.s	.02
	move.l	memilvd(pc),a6
	cmp.l	#'ALL!',(a6)		;disable deinterleaving?
	beq.s	.03			;yes
	bsr.w	chkcnf
	bne.s	.03
.02	bclr	#2,d3			;clear BMF_INTERLEAVED
.03	move.l	prdisp(pc),d4
	beq.s	.04
	move.l	memdisp(pc),a6
	bsr.w	chkcnf
	beq.s	.04
	btst	#0,d3			;BMF_CLEAR?
	bne.s	.04			;yes
	bclr	#1,d3			;no - clear BMF_DISPLAYABLE
.04	movem.l	(sp)+,d0-d2/a0
	move.l	_SysBase(pc),a6
	jsr	_LVOForbid(a6)
	cmp.l	#8,d2			;8 bitplanes?
	bhi	.nodisp			;more than 8 - passthrough...
	move.l	d0,d4
	subq.w	#1,d4
	asr.w	#6,d4
	addq.w	#1,d4
	asl.w	#3,d4
	mulu.w	d1,d4
	movem.l	d0-d3/a0,-(sp)
	sub.w	#stsize,sp		;variables placed on the stack
	move.l	d4,bpsize(sp)
	moveq	#2,d0
	and.l	d0,d3
	move.l	d3,bpflags(sp)	;transform BMF_DISPLAYABLE to MEMF_CHIP
	btst	#2,d3			;BMF_INTERLEAVED?
	beq.s	.05			;no
	mulu.l	d2,d4
	moveq	#1,d2
.05	move.l	d2,d4
	subq.l	#1,d4
	move.l	d4,bpcount(sp)
	lea	bptable(sp),a0
.1	move.l	bpsize(sp),d0
	move.l	bpflags(sp),d1
	movem.l	d4/a0,-(sp)
	move.l	_SysBase(pc),a6
	jsr	_LVOAllocVec(a6)
	movem.l	(sp)+,d4/a0
	move.l	d0,(a0)+
	dbf	d4,.1
	move.l	bpcount(sp),d4
	lea	bptable(sp),a0
	clr.l	d5
.2	move.l	(a0)+,a1
	tst.l	a1
	bne.s	.3
	moveq	#1,d5
.3	movem.l	d4/d5/a0,-(sp)
	move.l	_SysBase(pc),a6
	jsr	_LVOFreeVec(a6)
	movem.l	(sp)+,d4/d5/a0
	dbf	d4,.2
	add.w	#stsize,sp
	tst.l	d5
	beq.s	.noneed
	movem.l	(sp)+,d0-d3/a0
	clr.l	d0
	bra.s	.ex
.noneed	movem.l	(sp)+,d0-d3/a0
.nodisp	move.l	_GFXBase(pc),a6
	move.l	oldabm(pc),a5
	jsr	(a5)
.ex	move.l	_SysBase(pc),a6
	jsr	_LVOPermit(a6)
	movem.l	(sp)+,d4/d5/a1/a5-a6
	tst.l	d0
	rts

; Check process name existence in process list
; args:   d4 - number of strings
;         a6 - pointer to strings
;         a5 - pointer to process name
; result: d4 = 0 and Z flag if string not found
; trashes a1,a6,d0,d1,d4

chkcnf	subq.l	#1,d4
.nxn	move.l	a5,a1
	clr.l	d0
.nxb	move.b	(a1)+,d1
	btst	#6,d1
	beq.s	.nxc
	bclr	#5,d1
.nxc	cmp.b	(a6)+,d1
	beq.s	.nx2
	addq.l	#1,d0
.nx2	tst.b	(a6)
	bne.s	.nxb
	addq.l	#1,a6
	tst.l	d0
	bne.s	.nx3
	moveq	#1,d4
	rts
.nx3	dbf	d4,.nxn
	clr.l	d4
	rts

; Get process name (including CLI names) without paths
; args:   a6 - sysbase
; result: a5 - process name pointer
;         flag Z if name has zero length
; trashes a0,a1,a5,a6,d0,d4

getname	sub.l	a1,a1
	jsr	_LVOFindTask(a6)
	move.l	d0,a5
	cmp.b	#13,8(a5)
	bne.s	.4
	tst.l	pr_CLI(a5)
	beq.s	.4
	move.l	pr_CLI(a5),a1
	add.l	a1,a1
	add.l	a1,a1
	tst.l	cli_CommandName(a1)
	beq.s	.4
	move.l	cli_CommandName(a1),a5
	add.l	a5,a5
	add.l	a5,a5
	clr.l	d0
	move.b	(a5)+,d0
	beq.s	.6
	subq.l	#1,d0
	move.l	a5,a6
.1	move.b	(a6)+,d4
	cmp.b	#':',d4
	beq.s	.2
	cmp.b	#'/',d4
	bne.s	.3
.2	move.l	a6,a5
.3	dbf	d0,.1
	bra.s	.5
.4	move.l	LN_NAME(a5),a5
.5	tst.b	(a5)
.6	rts

oldabm		ds.l	1
oldopl		ds.l	1
prchip		ds.l	1
prilvd		ds.l	1
prdisp		ds.l	1
prncgx		ds.l	1
memchip		ds.l	1
memilvd		ds.l	1
memdisp		ds.l	1
memncgx		ds.l	1
_SysBase	ds.l	1
_GFXBase	ds.l	1

endofpatch

dn	dc.b	'dos.library',0
cn	dc.b	'cyber'
gn	dc.b	'graphics.library',0
sn	dc.b	'cgxsystem.library',0
namncgx	dc.b	'ENVARC:CyberGraphX/NOCGX',0
namchip	dc.b	'ENVARC:CyberGraphX/PLANES2CHIP',0
namilvd	dc.b	'ENVARC:CyberGraphX/INTERLEAVED',0
namdisp	dc.b	'ENVARC:CyberGraphX/DISPLAYABLE',0
	dc.b	 '$VER: CyberBugfiX 1.1 (29.01.01)  2001 Russian Digital Computing',13,10,0

	section	xdata,bss

pm		ds.l	1
fh		ds.l	1
returnMsg	ds.l	1
_DOSBase	ds.l	1
_IntuitionBase	ds.l	1
fib_buffer	ds.b	fib_SIZEOF

	end
